import { BaseControl } from "@wordpress/components";
import { MediaUpload } from "@wordpress/block-editor";

import { ImageRenderer } from "../../components";

const ImageSelector = ({
  value,
  label,
  help,
  className,
  onSelect = () => {},
}) => {
  const buttonText = value && value.url ? "Replace image" : "Select image";
  const buttonClass =
    value && value.url
      ? "components-button is-button is-default is-large"
      : "components-button editor-post-featured-image__toggle";

  return (
    <>
      <div style={{ width: "100%" }}>
        <div
          style={{
            display: "block",
            width: "100%",
            maxWidth: "300px",
            margin: "0 auto",
          }}
        >
          <BaseControl label={label} help={help} className={className}>
            <div class="editor-post-featured-image">
              <MediaUpload
                value={value.id}
                onSelect={onSelect}
                allowedTypes={["image"]}
                render={({ open }) => {
                  return (
                    <>
                      <button
                        onClick={open}
                        className="components-button editor-post-featured-image__preview"
                        type="button"
                        style={{ width: "100%" }}
                      >
                        <div className="components-responsive-wrapper">
                          <>
                            {value && value.url && (
                              <img
                                src={value.url}
                                className={className}
                                alt=""
                                style={{
                                  width: "100%",
                                  height: "auto",
                                  display: "block",
                                }}
                              />
                            )}
                          </>
                        </div>
                      </button>
                      <button
                        onClick={open}
                        class={buttonClass}
                        type="button"
                        style={{ display: "block", width: "100%" }}
                      >
                        {buttonText}
                      </button>
                      <button
                        onClick={() => onSelect(null)}
                        className="components-button is-link is-destructive"
                        style={{
                          display: value && value.url ? "inline-block" : "none",
                          width: "100%",
                          //textAlign: "center",
                          margin: "1rem 0 0",
                        }}
                      >
                        Remove Image
                      </button>
                    </>
                  );
                }}
              />
            </div>
          </BaseControl>
        </div>
      </div>
    </>
  );
};

export default ImageSelector;
